## Functions

<dl>
<dt><a href="#locate">locate(model, [options])</a> ⇒ <code>string</code></dt>
<dd><p>Locate place where model is storage.</p>
</dd>
<dt><a href="#locateById">locateById(id, [options])</a> ⇒ <code>string</code></dt>
<dd><p>Locate place by id.</p>
</dd>
<dt><a href="#getIdPropName">getIdPropName()</a> ⇒ <code>string</code></dt>
<dd><p>Name of id property.</p>
</dd>
<dt><a href="#getModelId">getModelId(model)</a> ⇒ <code>*</code></dt>
<dd><p>Get id from model.</p>
</dd>
<dt><a href="#isEmptyModelId">isEmptyModelId(model)</a> ⇒ <code>boolean</code></dt>
<dd><p>Is empty model id?</p>
</dd>
<dt><a href="#getModelManagerClass">getModelManagerClass()</a> ⇒ <code>ModelManagerInterface.prototype</code></dt>
<dd><p>ModelManagerClass related to this locator.</p>
</dd>
<dt><a href="#getRepositoryClass">getRepositoryClass()</a> ⇒ <code>RepositoryInterface.prototype</code></dt>
<dd><p>RepositoryClass related to this locator.</p>
</dd>
<dt><a href="#getInputTransformerClass">getInputTransformerClass()</a> ⇒ <code>TransformerInterface.prototype</code></dt>
<dd><p>Input Transformer class related to this locator.</p>
</dd>
<dt><a href="#getOutputTransformerClass">getOutputTransformerClass()</a> ⇒ <code>TransformerInterface.prototype</code></dt>
<dd><p>Input Transformer class related to this locator.</p>
</dd>
</dl>

<a name="locate"></a>

## locate(model, [options]) ⇒ <code>string</code>
Locate place where model is storage.

**Kind**: global function  

| Param | Type |
| --- | --- |
| model | <code>Model</code> | 
| [options] | <code>Object</code> | 

<a name="locateById"></a>

## locateById(id, [options]) ⇒ <code>string</code>
Locate place by id.

**Kind**: global function  

| Param | Type |
| --- | --- |
| id |  | 
| [options] | <code>Object</code> | 

<a name="getIdPropName"></a>

## getIdPropName() ⇒ <code>string</code>
Name of id property.

**Kind**: global function  
<a name="getModelId"></a>

## getModelId(model) ⇒ <code>\*</code>
Get id from model.

**Kind**: global function  

| Param | Type |
| --- | --- |
| model | <code>Model</code> | 

<a name="isEmptyModelId"></a>

## isEmptyModelId(model) ⇒ <code>boolean</code>
Is empty model id?

**Kind**: global function  

| Param | Type |
| --- | --- |
| model | <code>Model</code> | 

<a name="getModelManagerClass"></a>

## getModelManagerClass() ⇒ <code>ModelManagerInterface.prototype</code>
ModelManagerClass related to this locator.

**Kind**: global function  
<a name="getRepositoryClass"></a>

## getRepositoryClass() ⇒ <code>RepositoryInterface.prototype</code>
RepositoryClass related to this locator.

**Kind**: global function  
<a name="getInputTransformerClass"></a>

## getInputTransformerClass() ⇒ <code>TransformerInterface.prototype</code>
Input Transformer class related to this locator.

**Kind**: global function  
<a name="getOutputTransformerClass"></a>

## getOutputTransformerClass() ⇒ <code>TransformerInterface.prototype</code>
Input Transformer class related to this locator.

**Kind**: global function  
